/**
 * Este sera el programa del nivel del minijuego.
 *
 *
 *
 *
 */

 global

 	int muerto;
	int puntuacion;
	int puntos;

	int navesize;
	int navex;
	int navey;
	int quitaescudo;

	int numerouno;
	int fd;
 /**
  * \sa explosion()
  *
  *
  *
  */
 process explosion(int x, int y)
 private
 	int i;
	int mysonido;
 begin
	
	// Lo ponemos translucido.
	ALPHA=150;
	
	// Usaremos un contador para pasar de grafico.
 	i=0;

	// Ponemos el sonido de la explosion.
	mysonido = play_wav(sonidoexplosion,0);
	
	// Animamos la explosion.
	while(i < EXPLOSION_IMAGENES)

		// Cambiamos el grafico de la explosion
		graph=explosiones[i];

		i = i + 1;

		frame;

	end

	// Cambiamos el grafico de la explosion
	graph=explosiones[i];

	/*
	while(is_playing_wav(mysonido))

		frame;

	end
	*/

	// Ponemos el flag de muerto.
 	muerto=1;

 end

/**
 * \sa procesoescudo()
 *
 *
 *
 */
process procesoescudo();
begin

	z=31;
	ALPHA=150;

	graph=escudo;

	loop

		size=navesize;
		x=navex;
		y=navey;

		if(quitaescudo==1)

			quitaescudo=0;

			break;

		end

		frame;

	end

end

 
/**
 * \sa procesonave()
 *
 *
 *
 */
 process procesonave();
 private
 	int animacion;

	int mispuntos;

	int powerup;

	int acorazado;

	int invertido; 

	int timeracorazado;
begin

	// Posicionamos la nave.
	x=100;
	y=120;

	size=50;

	mispuntos=0;
	puntos=0;

	acorazado=0;
	invertido=0;

	quitaescudo=0;
	timeracorazado=100;
	
	// La nave debera estar detras de todos.
	z=32;

	// Definimos el estado base de la nave.
	animacion=3;

	// Ponemos el graficos de la nave.
	graph=nave[animacion];

	ARRIBA=_UP;
	ABAJO=_DOWN;
	IZQUIERDA=_LEFT;
	DERECHA=_RIGHT;

	loop

		
		// Miramos si se ha chocado en cuyo caso terminaremos con una
		// explosion y nos vamos.
		if(collision(type procesometeorito))

			// Si no tenemos el flag de acorzado.
			if(acorazado == 0)

				// Generamos la explosion
				explosion(x,y);

				break;

			end

		end

		// Si tenemos una explosion con un power up.
		if(collision(type procesotonel))

			// Sonido del powerup
			play_wav(powerupsound,0);

			// Se elige lo que va a ser segun una variable
			// aleatoria.
			powerup=rand(1,4);

			// Primer power up aumenta la nave de tamao.
			if(powerup == 1)

				if(size==100)

					size=50;

				else

					size=100;

				end

			// Segundo power up invierte los controles.
			elif(powerup == 2)

				if(invertido==0)

					ARRIBA=_DOWN;
					ABAJO=_UP;
					IZQUIERDA=_RIGHT;
					DERECHA=_LEFT;

					invertido=1;

				else

					ARRIBA=_UP;
					ABAJO=_DOWN;
					IZQUIERDA=_LEFT;
					DERECHA=_RIGHT;

					invertido=0;

				end



			// Tercer power up da puntos.
			elif(powerup == 3)

				puntos=puntos+10;

			// Cuarto power up cogemos escudo.
			else
				timeracorazado=0;

				if(acorazado==0)

					acorazado=1;

					quitaescudo=0;

					procesoescudo();

				end

			end

		end
	
		// Movimiento de la nave en la pantalla.
		if(key(IZQUIERDA))

			x=x-5;

		end

		if(key(DERECHA))

			x=x+5;

		end

		if(key(ARRIBA))

			// Definimos la animacion cuando la nave sube.
			if(animacion>0)

				animacion=animacion-1;

			end

			y=y-5;

		end

		if(key(ABAJO))

			// Definimos la animacion cuando la nave baja.
			if(animacion<(NAVEIMAGES-1))

				animacion=animacion+1;

			end

			y=y+5;

		else
			// Si no se pulsa ninguna tecla volvemo a posicion
			// inicial.
			if(not key(ARRIBA))

				if(animacion>3)

					animacion=animacion-1;

				end
				
				if(animacion<3)

					animacion=animacion+1;

				end

			end

		end

		// Limites de pantalla.
		if(x<0)

			x=0;

		end

		if(x>320)

			x=320;

		end

		if(y<0)

			y=0;

		end

		if(y>240)

			y=240;

		end

		// Cambiamos el grafico de la nave respecto de la tecla pulsada.
		graph=nave[animacion];

		mispuntos=mispuntos+1;

		if(mispuntos == 24)

			puntos = puntos + 1;

			mispuntos = 0;

		end
	
		delete_text(puntuacion);
	
		puntuacion = write_int(0,300,220,5,&puntos);

		// Damos los valores glovales para el escudo.
		navex=x;
		navey=y;
		navesize=size;
		
		if(timeracorazado<100)

			timeracorazado=timeracorazado+1;

			if(timeracorazado==100)

				quitaescudo=1;

				acorazado=0;

			end

		end
		
		frame;

	end

	// Si hemos superado la puntuacion la salvamos.
	if(puntos > numerouno)
		// Abrimos en modo escritura.
		fd = fopen("./data/puntos.dat",O_WRITE);

		// Escritura.
		fwrite(fd,puntos);

		// Cerramos el archivo.
		fclose(fd);

		// Cambiamos la variable numerouno.
		numerouno = puntos;

	end

 end
/**
 * \sa procesotonel()
 *
 *
 */
process procesotonel(int velocidadmaxima)
private
	int velocidad;
begin

	// Generamos los meteoritos fuera de la pantalla.
	// La x es fija, la y es aleatoria.
	x=400;
	y=rand(0,240);

	// Ponemos el grafico al proceso.
	graph=tonel;

	// Definiremos la velocidad del meteorito aleatoriamente.
	velocidad=rand(1,velocidadmaxima);

	// Asignamos una z respectiva de la velocidad,
	// Para que meteoritos de diferentes velocidades no hagan efectos malos
	// Al pasar unos encima de otros.
	z=velocidad%31;

	// Bucle de desplazamiento del meteorito.
	loop

		// movimiento del meteorito.
		x=x-velocidad;

		// Si colisiona con la nave lo eliminamos.
		if(collision(type procesonave))

			break;

		end

		// Definimos que si sale de la pantalla lo eliminamos.
		if(x<-200)
		
			break;
			
		end

		frame;

	end

	frame;

end

/**
 * \sa procesometeorito()
 *
 *
 */
process procesometeorito(int velocidadmaxima)
private
	int velocidad;
begin

	// Generamos los meteoritos fuera de la pantalla.
	// La x es fija, la y es aleatoria.
	x=400;
	y=rand(0,240);

	// Ponemos el grafico al proceso.
	graph=meteorito[rand(0,METEORITOS-1)];

	// Definiremos la velocidad del meteorito aleatoriamente.
	velocidad=rand(1,velocidadmaxima);

	// Asignamos una z respectiva de la velocidad,
	// Para que meteoritos de diferentes velocidades no hagan efectos malos
	// Al pasar unos encima de otros.
	z=velocidad%31;

	// Bucle de desplazamiento del meteorito.
	loop

		// movimiento del meteorito.
		x=x-velocidad;

		// Definimos que si sale de la pantalla lo eliminamos.
		if(x<-200)
		
			break;
			
		end

		frame;

	end

end

/**
 * \sa nivel()
 *
 *
 *
 */
 process nivel()
 private
 	int tiempo;
	int iteracion;
	int generador;
 begin

	// Iniciaremos el scroll.
 	start_scroll(0,0,estrellado,0,0,3);

	// pondremos la nave.
	procesonave();
	
	// Hacemos un fundido a la pantalla de nivel.
	fade_on();

	// Inicializamos el tiempo.
	tiempo=1;

	// Inicializamos generador.
	generador=1;

	loop
	
		// Hacemos avanzar el scroll.
		scroll[0].x0=scroll[0].x0 + 10;

		if(iteracion%generador==0)

			if(tiempo < 99)

				generador = rand(1,100-tiempo);

			else

				generador = 1;

			end

			procesometeorito(rand(10,tiempo*2));

			if(rand(1,10) == 1)

				procesotonel(rand(10,tiempo*2));

			end

		end

		iteracion=iteracion+1;

		if(iteracion == 200)

			iteracion=0;

			tiempo=tiempo+1;

		end

		frame;

	end

 end

/**
 * \sa mensaje_inicio()
 *
 *
 *
 */
 process mensaje_inicio()
 private
 	int i;
 begin
	x=160;
	y=50;
	graph=label;

	i=0;
	loop
		
		if(i < 300)
		
			ALPHA=i;

		else

			ALPHA=600-i;

		end
		
		i = (i + 10);

		if(i==600)
			i=0;
		end
		
		frame;
	end
 end
/**
 * \sa inicia_pantalla()
 *
 *
 */
 process inicia_pantalla()
 private
	int enmenu;
 begin

	// Si no existe el fichero lo creamos con cero.
	if(!file_exists("./data/puntos.dat"))

		// Abrimos en modo escritura.
		fd = fopen("./data/puntos.dat",O_WRITE);

		// La variable a meter con valor de cero.
		numerouno=0;

		// Escritura.
		fwrite(fd,numerouno);

		// Cerramos el archivo.
		fclose(fd);

	end
	
	// Cargamos los puntos del archivo de puntos.
	fd = fopen("./data/puntos.dat",O_READ);

	// Leemos el ultimo valor que se ha dado a los puntos.
	fread(fd,numerouno);

	// Cerramos el fichero.
	fclose(fd);

	// Marcamos el flag.
 	enmenu=0;
 	
	// Iniciamos la muscia del menu.
	play_wav(menumusica,-1);

	write(0,10,220,0,"Puntuacion a superar:");
	write_int(0,150,220,0,&numerouno);

	loop

		// Volvemos a dejar el flag de muerto
		// para volver a empezar otra partida.
		muerto=0;
		
		if(enmenu == 0)

			// Ponemos la pantalla de menu.
			put_screen(0,menu);

			// Hacemos fundido
			fade_on();

			// Ponemos el mensaje.
			mensaje_inicio();

			// Levantamos el flag.
			enmenu=1;

			// Si estamos pulsando escape ponemos otro flag.
			enmenu=2;

		end

		if((key(SALIR)) and (enmenu == 1))

					
			break;
			
		end

		// Scan code es para la version PC
		//if((scan_code!=SALIR) and (scan_code != 0))
		// El enter es para la version GP2X
		if(key(_enter))

			// Dejamos solo este proceso vivo.
			let_me_alone();

			// Apagado de rutina.
			fade_off();

			// iniciamos la pantalla.
			nivel();

			// Paramos toda musica.
			stop_wav(menumusica_wav);

			// Iniciamos la muscia del juego.
			play_wav(juegomusica,-1);

			// Borramos todos los textos.
			delete_text(ALL_TEXT);

			// Y entramos en un bucle del que saldremos cuando
			// Nos digan
			loop

				if((key(SALIR)) or (muerto==1))

					// Hacemos un fundido a negro.
					fade_off();

					// Dejamos al proceso solo.
					let_me_alone();

					delete_text(puntuacion);

					// Paramos la musica del juego.
					stop_wav(juegomusica_wav);
					
					// Iniciamos la muscia del menu.
					play_wav(menumusica,-1);

					// Ponemos el mensaje.
					mensaje_inicio();
			
					// Escribimos de nuevo la puntuacion
					write(0,10,220,0,"Puntuacion a superar:");
					write_int(0,150,220,0,&numerouno);

					
					// Volvemos a poner el flag.
					enmenu=0;

					// Paramos el scroll.
					stop_scroll(0);
					
					// Nos vamos del bucle de espera.
					break;
					
				end

				frame;

			end;

		end


		if((not key(SALIR)) and (muerto==0))

			enmenu=1;

		end

		
		frame;

	end

	let_me_alone();
	
 end
